<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">
<link rel="import" href="/ts/common-elements/iron-flex-layout-attributes/iron-flex-layout-attributes.html">
<link rel="import" href="/extern/bower_components/iron-icon/iron-icon.html">
<link rel="import" href="/extern/bower_components/iron-icons/iron-icons.html">
<link rel="import" href="/extern/bower_components/iron-pages/iron-pages.html">
<link rel="import" href="/extern/bower_components/paper-tabs/paper-tabs.html">
<link rel="import" href="/extern/bower_components/paper-listbox/paper-listbox.html">
<link rel="import" href="/extern/bower_components/paper-item/paper-item.html">
<link rel="import" href="/extern/bower_components/paper-fab/paper-fab.html">
<link rel="import" href="/extern/bower_components/neon-animation/neon-animated-pages.html">
<link rel="import" href="/extern/bower_components/neon-animation/neon-animatable.html">
<link rel="import" href="/extern/bower_components/neon-animation/animations/slide-left-animation.html">
<link rel="import" href="/extern/bower_components/neon-animation/animations/slide-right-animation.html">
<link rel="import" href="/extern/bower_components/neon-animation/animations/slide-from-left-animation.html">
<link rel="import" href="/extern/bower_components/neon-animation/animations/slide-from-right-animation.html">
<link rel="import" href="/ts/common-elements/relative-time/relative-time.html">
<link rel="import" href="/extern/bower_components/vaadin-grid/vaadin-grid.html">
<link rel="import" href="/ts/common-elements/charts/stacked-area-chart/stacked-area-chart.html">
<link rel="import" href="/ts/common-elements/charts/pie-chart/pie-chart.html">
<link rel="import" href="/ts/common-elements/file-saver-js/file-saver-js.html">
<link rel="import" href="/ts/common-elements/ts-ajax/ts-ajax.html">
<link rel="import" href="/ts/common-elements/auto-update/auto-update.html">

<dom-module id="ts-about">
  <template>
    <style include="reset-css"></style>
    <style include="iron-flex-layout-attributes"></style>

    <style>
:host{display:block}neon-animatable>div{border-bottom:1px dashed #D8D8D8}paper-fab,iron-icon[icon="error"]{height:3em;width:3em}paper-fab{margin-left:.5em}iron-icon[icon="error"]{color:var(--paper-red-600);margin-right:.5em}div[center]{text-align:center}p[tiny]{font-size:.8em;color:var(--paper-grey-600)}p[title]{color:var(--paper-grey-600);margin-top:2em;text-align:center;margin-bottom:0}paper-listbox{border-right:1px dashed #D8D8D8}

</style>

    <ts-ajax id="getCoreDump"
             callback="getCoreDump"
             data="{{coreDump}}"
             parameters='["filename"]'></ts-ajax>
    <ts-ajax id="getCoreDumps"
             callback="getCoreDumps"
             data="{{coreDumps}}"
             auto></ts-ajax>
    <ts-ajax id="getLogs"
             data="{{rawLogs}}"
             callback="getLogs"
             auto></ts-ajax>
    <auto-update id="getCPU"
                 callback="getCPU"
                 handle-as="text"
                 on-data-changed="addCPUData"
                 interval="3000"
                 headless></auto-update>
    <auto-update id="getMemory"
                 callback="getMemory"
                 handle-as="text"
                 on-data-changed="addMemoryData"
                 interval="60000"
                 headless></auto-update>




    <neon-animated-pages selected="{{selectedMode}}"
                         attr-for-selected="mode">

      <!-- <ts-about-info mode="info"></ts-about-info>
      <ts-about-coredumps mode="coredumps"></ts-about-coredumps> -->

      <neon-animatable mode="info"
                       entry-animation="slide-from-left-animation"
                       exit-animation="slide-left-animation">
        <template is="dom-if" if="{{thereAreCoreDumps(coreDumps)}}" restamp="true">
          <div horizontal layout align-center style="padding-bottom:5px;">
            <iron-icon icon="error"></iron-icon>
            <p>Your cell contains some core dumps!</p>
            <paper-fab icon="arrow-forward" on-click="gotoCoredumps"></paper-fab>
          </div>
        </template>
        <div horizontal layout flex-stretch-with-space>
          <div center>
            <p tiny>Version</p>
            <p>[[data.version]]</p>
          </div>
          <div center>
            <p tiny>Compiled</p>
            <relative-time date="[[data.compiled]]"></relative-time>
          </div>
          <div center>
            <p tiny>Started</p>
            <relative-time date="[[data.started]]"></relative-time>
          </div>
        </div>

        <div horizontal layout style="height:200px;">
          <div vertical layout flex>
            <p title>CPU usage</p>
            <stacked-area-chart id="cpuchart" flex data="{{cpudata}}" config="{{cpuconfig}}" configure-chart="{{cpuconfigjs}}"></stacked-area-chart>
          </div>
          <div vertical layout style="width:200px;">
            <p title>Memory usage</p>
            <pie-chart id="memchart" flex data="{{memdata}}" config="{{memconfig}}" configure-chart="{{memconfigjs}}"></pie-chart>
          </div>
        </div>

        <div>

          <template is="dom-if" if="{{!onlyOneLogfile(rawLogs)}}" restamp="true">
            <paper-tabs selected="{{selectedLog}}" scrollable>
              <template is="dom-repeat" items="[[filteredLogs]]" as="log">
                <paper-tab>[[log.file]]</paper-tab>
              </template>
            </paper-tabs>
          </template>
          <iron-pages selected="{{selectedLog}}">
            <template is="dom-repeat" items="[[filteredLogs]]" as="log" on-rendered-item-count-changed="insertFilters">
              <div>
                <vaadin-grid items="{{log.content}}"
                             columns="{{getLogsColumns()}}"></vaadin-grid>
              </div>
            </template>
          </iron-pages>

        </div>

      </neon-animatable>

      <neon-animatable mode="coredumps"
                       entry-animation="slide-from-right-animation"
                       exit-animation="slide-right-animation">
        <div horizontal layout flex-stretch align-center style="padding-bottom:5px;">
          <paper-fab icon="arrow-back" on-click="gotoInfo"></paper-fab>
          <paper-button id="download" disabled on-click="downloadCoreDump"><iron-icon icon="file-download"></iron-icon>download</paper-button>

        </div>
        <div horizontal layout>
          <paper-listbox selected="{{selectedCoreDump}}">
            <template is="dom-repeat" items="[[coreDumps]]" as="filename">
              <paper-item>[[filename]]</paper-item>
            </template>
          </paper-listbox>
          <div flex horizontal layout align-center flex-center>
            <p style="white-space: pre-wrap;margin:5px;">[[coreDump.output]]</p>
          </div>
        </div>
      </neon-animatable>

    </neon-animated-pages>

  </template>
  <script>
Polymer({is:"ts-about",properties:{data:Object,selectedMode:{type:String,value:"info"},rawLogs:Array,selectedLog:{type:Number,value:0},processedLogs:{type:Array,computed:"processLogs(rawLogs)"},filteredLogs:{type:Array,computed:"filterLogs(processedLogs, filter_message, filter_location, show_warnings, show_errors, show_fatals)"},filter_message:{type:String,value:""},filter_location:{type:String,value:""},show_warnings:{type:Boolean,value:!0},show_errors:{type:Boolean,value:!0},show_fatals:{type:Boolean,value:!0},coreDumps:{type:Array},selectedCoreDump:{type:Number,observer:"selectedCoreDumpChanged"},coreDump:{type:Object,value:function(){return{output:"Select a core dump file"}}},cpudata:{type:Array,value:function(){return[{key:"usr",values:[]},{key:"nice",values:[]},{key:"sys",values:[]},{key:"iowait",values:[]},{key:"irq",values:[]},{key:"soft",values:[]},{key:"steal",values:[]},{key:"guest",values:[]},{key:"idle",values:[]}]}},cpuconfig:{type:Object,value:function(){return{x:function(d){return d[0]},y:function(d){return d[1]},clipEdge:!0,useInteractiveGuideline:!0,color:["#42A5F5","#D4E157","#EF5350","#26A69A","#EC407A","#78909C","#8D6E63","#AB47BC","white"],showControls:!1,duration:0}}},cpuconfigjs:{type:Function,value:function(){return function(){this._chart.style("expand"),this._chart.xAxis.tickFormat(function(d){return d3.time.format("%X")(new Date(d))}),this._chart.yAxis.tickFormat(d3.format(",.2f"))}}},memdata:{type:Array,value:function(){return[{x:"used",y:0},{x:"free",y:0}]}},memconfig:{type:Object,value:function(){return{showLabels:!0}}},memconfigjs:{type:Function,value:function(){return function(){this._chart.valueFormat(function(kbytes){var format=d3.format(".2f");return 1024>kbytes?format(kbytes)+"kB":1048576>kbytes?format(kbytes/1024)+"MB":1073741824>kbytes?format(kbytes/1024/1024)+"GB":format(kbytes/1024/1024/1024)+"TB"})}}}},gotoCoredumps:function(){this.selectedMode="coredumps"},gotoInfo:function(){this.selectedMode="info"},selectedCoreDumpChanged:function(i){this.coreDumps[i]&&(this.$.getCoreDump.filename=this.coreDumps[i],this.$.getCoreDump.generateRequest(),this.set("coreDump.output","Loading "+this.coreDumps[i]),Polymer.dom(this.root).querySelector("#download").disabled=!1)},downloadCoreDump:function(){var blob=new Blob([this.coreDump.output],{type:"text/plain;charset=utf-8"});saveAs(blob,this.coreDumps[this.selectedCoreDump].substring(5)+".txt")},addMemoryData:function(){var line=this.$.getMemory.data.split("\n")[1].split(" ").filter(Boolean);this.memdata[0].y=Number(line[2]),this.memdata[1].y=Number(line[3]),this.$.memchart._dataChanged()},thereAreCoreDumps:function(coreDumps){return 0!=coreDumps.length},addCPUData:function(){var line=this.$.getCPU.data.split("\n")[4].split(" ").filter(Boolean),timestamp=new Date;this.cpudata[0].values.push([timestamp,Number(line[2])]),this.cpudata[1].values.push([timestamp,Number(line[3])]),this.cpudata[2].values.push([timestamp,Number(line[4])]),this.cpudata[3].values.push([timestamp,Number(line[5])]),this.cpudata[4].values.push([timestamp,Number(line[6])]),this.cpudata[5].values.push([timestamp,Number(line[7])]),this.cpudata[6].values.push([timestamp,Number(line[8])]),this.cpudata[7].values.push([timestamp,Number(line[9])]),this.cpudata[8].values.push([timestamp,Number(line[10])]),this.$.cpuchart._dataChanged()},getLogsColumns:function(){return[{name:"time",renderer:this.timeRenderer,hidable:!0},{name:"type",hidable:!0},{name:"message",hidable:!0},{name:"location",hidable:!0}]},processLogs:function(rawLogs){var processedlogs=[];if(rawLogs)for(var i=0;i<rawLogs.length;i++){var rawLog=rawLogs[i],processedLog={};processedLog.file=rawLog.file,processedLog.content=[];var lines=rawLog.content.split("\n");lines.pop();for(var j=0;j<lines.length;j++){var record={},line=lines[j].split(" ");switch(record.time=line[1]+" "+line[0]+" "+line[2]+" "+line[3].substring(0,line[3].length-4),line[5]){case"WARN":record.type="warning";break;case"ERROR":record.type="error";break;case"FATAL":record.type="fatal";break;default:line[5]}""==line[6]?record.location=line[7]:record.location=line[6],""==line[6]?record.message=line.splice(10).join(" "):record.message=line.splice(9).join(" "),processedLog.content.unshift(record)}processedlogs.push(processedLog)}return processedlogs},filterLogs:function(processedLogs,filter_message,filter_location,show_warnings,show_errors,show_fatals){var filteredLogs=[];if(processedLogs)for(var i=0;i<processedLogs.length;i++){var processedLog=processedLogs[i],filteredLog={};filteredLog.file=processedLog.file,filteredLog.content=[];for(var j=0;j<processedLog.content.length;j++){var record=processedLog.content[j];-1!=record.message.toLowerCase().indexOf(filter_message)&&-1!=record.location.toLowerCase().indexOf(filter_location)&&("warning"==record.type&&show_warnings||"error"==record.type&&show_errors||"fatal"==record.type&&show_fatals)&&filteredLog.content.push(record)}filteredLogs.push(filteredLog)}return filteredLogs},timeRenderer:function(cell){cell.element.innerHTML="";var relativetime=document.createElement("relative-time");relativetime.date=cell.data,cell.element.appendChild(relativetime)},onlyOneLogfile:function(logs){return 1==logs.length},insertFilters:function(event){var tables=Polymer.dom(this.root).querySelectorAll("vaadin-grid");this.warningboxes=[],this.errorboxes=[],this.fatalboxes=[],this.messagefilters=[],this.locationfilters=[];for(var i=0;i<tables.length;i++){var target=tables[i];if(1==target.header.rowCount){var typeFilter=document.createElement("div"),warningbox=document.createElement("label"),warningcheckbox=document.createElement("input");warningcheckbox.setAttribute("type","checkbox"),warningcheckbox.style.position="static",warningcheckbox.style.opacity="1",warningcheckbox.checked=!0,warningcheckbox.addEventListener("change",function(e){console.log(e);var target=e.target||e.path[0];this.show_warnings=target.checked;for(var i=0;i<this.warningboxes.length;i++)this.warningboxes[i].checked=target.checked}.bind(this)),this.warningboxes.push(warningcheckbox),warningbox.appendChild(warningcheckbox),warningbox.appendChild(document.createTextNode("show warnings")),typeFilter.appendChild(warningbox);var br2=document.createElement("br");typeFilter.appendChild(br2);var errorbox=document.createElement("label"),errorcheckbox=document.createElement("input");errorcheckbox.setAttribute("type","checkbox"),errorcheckbox.style.position="static",errorcheckbox.style.opacity="1",errorcheckbox.checked=!0,errorcheckbox.addEventListener("change",function(e){console.log(e);var target=e.target||e.path[0];this.show_errors=target.checked;for(var i=0;i<this.errorboxes.length;i++)this.errorboxes[i].checked=target.checked}.bind(this)),this.errorboxes.push(errorcheckbox),errorbox.appendChild(errorcheckbox),errorbox.appendChild(document.createTextNode("show errors")),typeFilter.appendChild(errorbox);var br2=document.createElement("br");typeFilter.appendChild(br2);var fatalbox=document.createElement("label"),fatalcheckbox=document.createElement("input");fatalcheckbox.setAttribute("type","checkbox"),fatalcheckbox.style.position="static",fatalcheckbox.style.opacity="1",fatalcheckbox.checked=!0,fatalcheckbox.addEventListener("change",function(e){console.log(e);var target=e.target||e.path[0];this.show_fatals=target.checked;for(var i=0;i<this.fatalboxes.length;i++)this.fatalboxes[i].checked=target.checked}.bind(this)),this.fatalboxes.push(fatalcheckbox),fatalbox.appendChild(fatalcheckbox),fatalbox.appendChild(document.createTextNode("show fatals")),typeFilter.appendChild(fatalbox);var br2=document.createElement("br");typeFilter.appendChild(br2);var messageFilter=document.createElement("paper-input");messageFilter.noLabelFloat=!0,messageFilter.label="filter...",messageFilter.style.width="100%",messageFilter.addEventListener("value-changed",function(e){this.filter_message=e.detail.value;for(var i=0;i<this.messagefilters.length;i++)this.messagefilters[i].value=e.detail.value}.bind(this)),this.messagefilters.push(messageFilter);var locationFilter=document.createElement("paper-input");locationFilter.noLabelFloat=!0,locationFilter.label="filter...",locationFilter.style.width="100%",locationFilter.addEventListener("value-changed",function(e){this.filter_location=e.detail.value;for(var i=0;i<this.locationfilters.length;i++)this.locationfilters[i].value=e.detail.value}.bind(this)),this.locationfilters.push(locationFilter),target.header.addRow(1,["",typeFilter,messageFilter,locationFilter])}}}});
</script>
</dom-module>
